using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using EPiServer.Shell.Gadgets;
using EPiServer.Core;
using FindPages.Models;
using EPiServer.Shell.Extensions;
using EPiServer;

namespace FindPages.Controllers
{
    [Gadget(ClientScriptInitMethod = "criteria.init")]
    [EPiServer.Shell.Web.ScriptResource("Content/Jscript1.js")]


    public class CriteriaController : Controller
    {
          
        public ActionResult Search(string queryFields, IList<Criteria> query)
        {
           
            PropertyCriteriaCollection coll = new PropertyCriteriaCollection();
            foreach (var item in query)
            {
                PropertyCriteria crit = new PropertyCriteria();
                crit.IsNull = item.IsNull == "on";
                crit.Required = item.Required == "on";
                crit.Value = item.Value;
                crit.Type = (PropertyDataType)  Enum.Parse(typeof(PropertyDataType), item.Type);
                crit.Condition = (EPiServer.Filters.CompareCondition) Enum.Parse(typeof(EPiServer.Filters.CompareCondition), item.Condition);

                if (item.Name == string.Empty)
                    crit.Name = item.CommonPropertyName; 
                
                else
                    crit.Name = item.Name;


                coll.Add(crit);

            }

          PageDataCollection pdcoll =  DataFactory.Instance.FindPagesWithCriteria(PageReference.StartPage, coll);

          if (pdcoll.Count > 0)
          {
              List<FindPages.Models.ResultItem> results = new List<ResultItem>();
              foreach (var page in pdcoll)
              {
                  results.Add( new ResultItem { PageName = page.PageName, EditUrl=UriSupport.ResolveUrlFromUIBySettings("edit/default.aspx?id=" + page.PageLink.ToString()) } );
              }

              
              return View("Result", results);

          }
          else
              return View("Index");
               
        }
        
        public ActionResult Index()
        {
           
            return View();
        }


        public ActionResult Conditions()
        {

            return Json( CriteriaSetup.Conditions);
        }

        public ActionResult ValueTypes()
        {

            return Json(CriteriaSetup.ValueTypes);
        }

        public ActionResult CommonProperties()
        {

            return Json(CriteriaSetup.CommonPropertyNames);
        }

    }
}
